@ECHO OFF
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


IF '%1'=='' GOTO GO_END
IF '%2'=='' GOTO GO_END
IF '%3'=='' GOTO GO_END
IF '%4'=='' GOTO GO_END
IF '%5'=='' GOTO GO_END
IF '%6'=='' GOTO GO_END
IF '%7'=='' GOTO GO_END
IF '%8'=='' GOTO GO_END

ECHO.
ECHO =====================================================================
ECHO           %7 Build Cross for %4-%5  
ECHO =====================================================================


if NOT EXIST C:\lazarus\lazarus.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     ERROR:  Lazarus Base IDE NOT Exists  
ECHO             Please Build Lazarus IDE first.... 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

if NOT EXIST C:\pp\bin\%2\make.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     ERROR:  %1 Make.exe NOT Exists  
ECHO             Sorry, build STOP
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

if NOT EXIST C:\pp\units\%4-%5\rtl\system.ppu (
ECHO.
ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ECHO INFO: %1 Cross Element for %4-%5 NOT exists 
ECHO       script will try to build this element...
ECHO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ECHO.
START /B /WAIT x_FPC_Build_Cross.bat %1 %2 %3 %4 %5 %6 
)


if NOT EXIST C:\pp\bin\%2\%6.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     ERROR:  %1 Cross Compiler for %4  NOT Exists 
ECHO             Sorry, build STOP
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)


ECHO.
ECHO --------------- Clear OLD %4-%5 units ----------------  


rmdir /S /Q C:\lazarus\components\synedit\units\%4-%5
rmdir /S /Q C:\lazarus\ideintf\units\%4-%5
rmdir /S /Q C:\lazarus\lcl\units\%4-%5
rmdir /S /Q C:\lazarus\packager\units\%4-%5


ECHO.
ECHO --------------- Build LCL --------------------------------

REM START /D c:\lazarus\ /B /WAIT C:\pp\bin\%2\make.exe lcl LCL_PLATFORM=%8 CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe 

START /D c:\lazarus\ /B /WAIT C:\pp\bin\%2\make.exe lcl CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe

ECHO.
ECHO --------------- Build components ------------------------

START /D c:\lazarus\ /B /WAIT C:\pp\bin\%2\make.exe components CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe

ECHO.
ECHO --------------- Build packager --------------------------

START /D c:\lazarus\ /B /WAIT C:\pp\bin\%2\make.exe packager/registration CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe

ECHO.
ECHO --------------- Build ideintf ---------------------------

START /D c:\lazarus\ /B /WAIT C:\pp\bin\%2\make.exe ideintf CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe


if '%8'=='xxx' (
ECHO INFO: !!!!!!! %7 %4-%5 Element Build OK !!!!!!
ECHO.
)

IF EXIST C:\lazarus\lcl\units\%4-%5\%8 (
ECHO.
ECHO --------------- Copy Units to PLATFORM Directory ----------------
xcopy /E /R /Y C:\lazarus\lcl\units\%4-%5\%8 C:\lazarus\lcl\units\%4-%5\win32\
rmdir /S /Q C:\lazarus\lcl\units\%4-%5\%8
ECHO.
ECHO INFO: !!!!!!! %7 %4-%5 Element Build OK !!!!!!
ECHO.
) ELSE (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     ERROR:  lazarus\lcl\units\%4-%5\ NOT Exists
ECHO             Sorry, %7 %4-%5 Element NOT Build 
ECHO ???????????????????????????????????????????????????????????
ECHO.
)

EXIT

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

:GO_END

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     ERROR:  Sorry NO Script Parameters. 
ECHO ???????????????????????????????????????????????????????????
ECHO.

EXIT