@ECHO OFF
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

if NOT EXIST C:\Windows\SysWOW64 (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   INFO: Sorry, Your Operating System NOT support 64Bits 
ECHO          can NOT build FreePascal for x86_64-win64                
ECHO ???????????????????????????????????????????????????????????
ECHO.
GOTO END
)

ECHO.
ECHO =====================================================================
ECHO                  Build FreePascal 64bit  
ECHO =====================================================================


if NOT EXIST c:\pp\Makefile.fpc (
ECHO INFO: FreePascal Source NOT EXIST!!!
CALL x_FPC_Extract_Source_From_ZipFile
IF NOT ERRORLEVEL 0 GOTO ERROR
)

if NOT EXIST C:\pp\bin\x86_64-win64\make.exe (
ECHO.
ECHO -------------------------------------------------------
ECHO                  Copy FreePascal 64bit Bin Files 
ECHO -------------------------------------------------------
xcopy /E /R /Y ..\bin\x86_64-win64 C:\pp\bin\x86_64-win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
xcopy /E /R /Y ..\binGDB\win64 C:\pp\binGDB\win64\
IF NOT ERRORLEVEL 0 GOTO ERROR
)

ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean FreePascal 64bit 
ECHO -------------------------------------------------------
pushd c:\pp\
C:\pp\bin\x86_64-win64\make.exe clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

ECHO.
ECHO -------------------------------------------------------
ECHO                  Build FreePascal 64bit 
ECHO -------------------------------------------------------
pushd c:\pp\
C:\pp\bin\x86_64-win64\make.exe all
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

ECHO.
ECHO -------------------------------------------------------
ECHO                  Install FreePascal 64bit 
ECHO -------------------------------------------------------
pushd c:\pp\
C:\pp\bin\x86_64-win64\make.exe install
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

ECHO.
ECHO -------------------------------------------------------
ECHO                  Clean FreePascal 64bit 
ECHO -------------------------------------------------------
pushd c:\pp
C:\pp\bin\x86_64-win64\make.exe clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

GOTO END

:ERROR
echo error
exit 1
:END
