@ECHO OFF
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


ECHO.
ECHO ----------------------------------------------------------
ECHO                  Clear Lazarus Simple 
ECHO ----------------------------------------------------------

if NOT EXIST c:\lazarus\ (
ECHO ERROR: Lazarus Directory NOT EXIST !!!
GOTO ERROR
)

if NOT EXIST C:\pp\ (
ECHO ERROR: FreePascal Directory NOT EXIST !!!
GOTO ERROR
)

IF EXIST C:\lazarus\xxlazarusWin32.txt (
  pushd c:\lazarus\
  C:\pp\bin\i386-win32\make.exe clean
  IF NOT ERRORLEVEL 0 GOTO ERROR
  popd  
)
IF EXIST C:\lazarus\xxlazarusWin64.txt (
  pushd c:\lazarus\
  C:\pp\bin\x86_64-win64\make.exe clean
  IF NOT ERRORLEVEL 0 GOTO ERROR
  popd  

)

GOTO END

:ERROR 
echo an error happened in %0
exit 1
:END
